# generated by datamodel-codegen:
#   filename:  api_constrained.yaml
#   timestamp: 2019-07-26T00:00:00+00:00

from __future__ import annotations

from typing import Annotated, List, Optional

from pydantic import AnyUrl, BaseModel, Field


class Pet(BaseModel):
    id: Annotated[int, Field(ge=0.0)]
    name: Annotated[str, Field(max_length=256)]
    tag: Annotated[Optional[str], Field(max_length=64)] = None


class Pets(BaseModel):
    __root__: Annotated[List[Pet], Field(max_items=10, min_items=1)]


class UID(BaseModel):
    __root__: Annotated[int, Field(ge=0.0)]


class Phone(BaseModel):
    __root__: Annotated[str, Field(min_length=3)]


class FaxItem(BaseModel):
    __root__: Annotated[str, Field(min_length=3)]


class User(BaseModel):
    id: Annotated[int, Field(ge=0.0)]
    name: Annotated[str, Field(max_length=256)]
    tag: Annotated[Optional[str], Field(max_length=64)] = None
    uid: UID
    phones: Annotated[Optional[List[Phone]], Field(max_items=10)] = None
    fax: Optional[List[FaxItem]] = None


class Users(BaseModel):
    __root__: List[User]


class Id(BaseModel):
    __root__: str


class Rules(BaseModel):
    __root__: List[str]


class Error(BaseModel):
    code: int
    message: str


class Api(BaseModel):
    apiKey: Annotated[
        Optional[str], Field(description='To be used as a dataset parameter value')
    ] = None
    apiVersionNumber: Annotated[
        Optional[str], Field(description='To be used as a version parameter value')
    ] = None
    apiUrl: Annotated[
        Optional[AnyUrl], Field(description="The URL describing the dataset's fields")
    ] = None
    apiDocumentationUrl: Annotated[
        Optional[AnyUrl], Field(description='A URL to the API console for each API')
    ] = None


class Apis(BaseModel):
    __root__: List[Api]


class Event(BaseModel):
    name: Optional[str] = None


class Result(BaseModel):
    event: Optional[Event] = None
